<template>
  <div id="lecture_keywords_editor_wrapper">
    <div v-show="extractMode === 0">
      <el-row>
        <el-col :span="14">
          <h3>{{ $t('KEYWORD.L_REGISTER') }}</h3>
            <!-- {{ keywordList }} -->
          <!--<draggable element="div" v-model="keywordList" :options="dragOptions">
            <transition-group type="transition">
              <el-tag class="tag" type="primary" v-for="k in keywordList" :key="k" closable @close="onClick('DELETE_TAG', k)">{{ k }}</el-tag>
            </transition-group>
          </draggable>-->
          <el-form @submit.native.prevent :model="input" :rules="rules" ref="elForm" label-width="125px" style="max-width: 400px;">
            <el-form-item :label="$t('KEYWORD.ENTER')" prop="keyword">
              <el-input v-model="input.keyword" @keydown.enter.native="onClick('ADD')"></el-input>
            </el-form-item>
            <el-form-item :label="$t('KEYWORD.LEVEL')" prop="weight">
              <el-input v-model="input.weight" type="number" min="1" max="100" @keydown.enter.native="onClick('ADD')"></el-input>
            </el-form-item>
          </el-form>
          <el-button style="margin-left:125px;" type="primary" @click="onClick('ADD')">{{ $t('KEYWORD.REGISTER') }}</el-button>
          <el-button style="margin-left:5px;" type="primary" @click="pastKeywordVisible = true">{{ $t('KEYWORD.ENRLL_PREV_KEY') }}</el-button>
          <el-dialog :title="$t('KEYWORD.ENRLL_PREV_KEY')" :visible.sync="pastKeywordVisible" width="40%">
            <div>
              <el-radio v-model="sorting" label="upper" @change="sortUP()">오름차순</el-radio>
              <el-radio v-model="sorting" label="lower" @change="sortDOWN()">내림차순</el-radio>
              <hr>
              <el-checkbox-group v-model="checkList">
                <el-checkbox v-for="item in pastKeyword" :key="item.keyword" :label="item.keyword" >{{item.keyword}}</el-checkbox>
              </el-checkbox-group>
              <el-input id="input_keyword_point" v-model="keywordPoint" :placeholder="$t('LECTURE_MANAGE.ALLOTS')" style="width: 200px"></el-input>
              <el-button @click="onClick('IMPORT_KEYWORD')" style="width: 100px">{{ $t('QUESTION.ADD') }}</el-button>
              <el-button @click="onClick('ALL_KEYWORD')">{{ all_select ? $t('QUESTION.ALL_SLCT_CLE') : $t('QUESTION.ALL_SLCT')}}</el-button><br><br>
            </div>
          </el-dialog>
          <!-- <el-button style="position: relative; left: 125px" type="primary" @click="onClick('KEYWORD_EXTRACT_STEP_1')">자동 추출</el-button> -->
          <el-popover
            style="margin-left:5px;"
            placement="top-start"
            width="450"
            trigger="hover">
            <el-table :data="notice1">
              <el-table-column width="150" prop="title" :label="$t('LECTURE_LIST.TYPE')"></el-table-column>
              <el-table-column width="300" prop="content" :label="$t('LECTURE.CONTENT')"></el-table-column>
            </el-table>
            <i class="el-icon-question fa-lg" slot="reference"></i>
          </el-popover>
        </el-col>
        <el-col :span="10">
          <div id="lecture_keywords_table_wrapper">
            <div class="box-container" style="display: flex; justify-content: flex-end">
              <div style="width: auto; margin-right: 10px;">
                <a :href="downloadLink" download="keywordListForm">
                  <el-button type="success">
                    {{ $t('KEYWORD.FORM_DWNLD') }}
                  </el-button>
                </a>
              </div>
              <div style="width: auto; margin-right: 10px;">
                <el-upload
                  :show-file-list="false"
                  action=""
                  :on-change="handleChange"
                  :on-remove="handleRemove"
                  :on-exceed="handleExceed"
                  accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                  :auto-upload="false">
                  <el-button type="primary">
                    {{ $t('KEYWORD.UP_EXCEL') }}
                  </el-button>
                </el-upload>
              </div>
              <div>
                <el-button type="primary" @click="onClick('EXPORT_EXCEL')">
                  {{ $t('KEYWORD.DWN_EXCEL') }}
                </el-button>
              </div>
              <el-popover
                style="margin-left:5px;"
                placement="top-start"
                width="450"
                trigger="hover">
                <el-table :data="notice2">
                  <el-table-column width="150" prop="title" :label="$t('LECTURE_LIST.TYPE')"></el-table-column>
                  <el-table-column width="300" prop="content" :label="$t('LECTURE.CONTENT')"></el-table-column>
                </el-table>
                <i class="el-icon-question fa-lg" slot="reference"></i>
              </el-popover>
            </div>
            <table id="table_design" :data="keywordList">
              <thead>
                <tr>
                  <td>{{ $t('KEYWORD.LEC_KEY') }}</td>
                  <td>{{ $t('MAP.IMPORTANCE') }}</td>
                  <td></td>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(k, index) in keywordList" :key="index">
                  <td>
                    <el-input v-model="k.keyword" v-show="k.edit"></el-input>
                    <span v-show="!k.edit">{{ k.keyword }}</span>
                  </td>
                  <td>
                    <el-input v-model="k.weight" type="number" min=1 max=100 v-show="k.edit"></el-input>
                    <span v-show="!k.edit">{{ k.weight }}</span>
                  </td>
                  <td>
                    <el-button type="small" @click="onClick('EDIT_KEYWORD', k)">{{ k.edit ? $t('KEYWORD.CONFIRM') : $t('KEYWORD.EDIT') }}</el-button>
                    <template v-if="k.edit === true">
                      <el-button type="small" @click="onClick('CANCEL_EDIT', k)">{{ $t('KEYWORD.CANCEL') }}</el-button>
                    </template>
                    <el-button type="small" @click="onClick('DELETE_TAG', k)">{{ $t('KEYWORD.DELETE') }}</el-button>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </el-col>
      </el-row>
    </div>
    
    <!-- 자동 추출 관련 화면 -->
    <div v-show="extractMode !== 0">
      <el-button @click="clearKeywordTab" icon="el-icon-back">{{ $t('BOARD.BACK') }}</el-button>
    </div> 
    <div v-show="extractMode === 1">
      <h3>{{ $t('KEYWORD.AUTO_EXTRACT') }}</h3>
      <h5>{{ $t('KEYWORD.STEP1') }}</h5>
      <el-table
      ref="multipleTable"
      :data="fileList"
      style="width: 100%"
      @selection-change="handleSelectionChange">
      <el-table-column
        type="selection"
        width="55">
      </el-table-column>
      <el-table-column :label="$t('KEYWORD.UPLOADED_FILE')">
        <template slot-scope="scope">{{ scope.row.name }}</template>
      </el-table-column>
    </el-table>
    <el-button @click="onClick('KEYWORD_EXTRACT_STEP_2')">{{ $t('KEYWORD.NEXT') }}</el-button>
    </div>

    <div v-show="extractMode === 2">
      <h3>{{ $t('KEYWORD.AUTO_EXTRACT') }}</h3>
      <h5>{{ $t('KEYWORD.STEP2') }}</h5>
      <el-form @submit.native.prevent :model="input" :rules="rules" ref="elForm" label-width="125px" style="max-width: 400px;">
        <el-form-item label="w1" prop="keyword">
          <el-input v-model="wordPercentage"></el-input>
        </el-form-item>
        <el-form-item label="w2" prop="weight">
          <el-input v-model="fileAtLeast"></el-input>
        </el-form-item>
      </el-form>
      <p> {{ $t('KEYWORD.W1') }} </p>
      <p> {{ $t('KEYWORD.W2') }} </p>
      <el-button @click="onClick('KEYWORD_EXTRACT_STEP_1')">{{ $t('KEYWORD.PREVIOUS') }}</el-button>
      <el-button @click="onClick('KEYWORD_EXTRACT_STEP_3')">{{ $t('KEYWORD.NEXT') }}</el-button>
    </div>

    <div v-show="extractMode === 3">
      <h3>{{ $t('KEYWORD.AUTO_EXTRACT') }}</h3>
      <h5>{{ $t('KEYWORD.EXTRACT_IN_PROG') }}</h5>
      <i style="font-size: 30px;" class="fas el-icon-loading"></i>
    </div>

    <div v-show="extractMode === 4">
      <h3>{{ $t('KEYWORD.AUTO_EXTRACT') }}</h3>
      <h5>{{ $t('KEYWORD.W3') }}</h5>
      <el-table :data="extractedKeywordList">
        <el-table-column :label="$t('KEYWORD.EXTRACT_KEYWORD')" align="center" prop="keyword">
        </el-table-column>
        <el-table-column :label="$t('KEYWORD.IMPORTANCE')" align="center" prop="score">
        </el-table-column>
        <el-table-column label="" align="center">
          <template slot-scope="scope">
            <el-button type="primary" @click="onClick('ADD_KEYWORD',scope.row)">{{ $t('KEYWORD.ADD') }}</el-button>
            <!-- TODO: <el-button type="danger">불용어로 추가</el-button> TODO: 불용어를 넣는다면 어디서 삭제할까요?-->
          </template>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
import deepCopy from 'deep-copy';
import draggable from 'vuedraggable';
import XLSX from 'xlsx';
// import { saveAs } from 'file-saver';
import TableExport from 'tableexport';
import { mapMutations, mapState, mapGetters, mapActions } from 'vuex';
import { EventBus } from '../../event-bus';
import lectureService from '../../services/lectureService';
import classService from '../../services/classService';
import { baseUrl } from '../../services/config';

export default {
  name: 'LectureKeywordsEditor',
  components: {
    draggable,
  },
  async mounted() {
    const vm = this;
    EventBus.$on('clearKeywordTab', vm.clearKeywordTab);
    const res = await classService.getClass({
      id: vm.classId,
    });
    res.data.lectures.forEach((x) => {
      if (x.lecture_id !== vm.lectureId) {
        x.lecture_keywords.forEach((y) => {
          let flag = false;
          vm.pastKeyword.forEach((z) => {
            if (y.keyword === z.keyword) {
              flag = true;
            }
          });
          if (flag === false) {
            const tmp = {};
            tmp.keyword = y.keyword;
            vm.pastKeyword.push(tmp);
          }
        });
      }
    });
  },
  data() {
    return {
      wordPercentage: 0.5,
      fileAtLeast: 0,
      multipleSelection: [], // 추출 파일목록 체크박스값
      fileList: [], // 추출 파일 대상 목록
      extractMode: 0, // 0 : 키워드 수동 등록 화면, 1 ~ 3 : 키워드 자동 등록 과정
      extractedKeywordList: [],
      input: {
        keyword: '',
        weight: 1,
      },
      rules: {
        keyword: {
          required: true,
          message: this.$t('KEYWORD.ONE_LETTER_KEY'),
          trigger: 'change',
        },
        weight: {
          required: false,
          message: this.$t('KEYWORD.IMPORTANCE_NUM'),
        },
      },
      dragOptions: {
        animation: 0,
        group: 'description',
        disable: false,
      },
      /*
      notice: [{
        title: '키워드 등록',
        content: '입력한 강의 키워드 - 중요도쌍을 등록합니다.',
      }, {
        title: '자동 추출',
        content: '미리 등록된 강의 자료로 부터 키워드-중요도쌍을 추천합니다. 이 기능을 사용하려면, 먼저 강의자료를 등록해야 합니다.',
      }], */
      notice1: [{
        title: this.$t('KEYWORD.REGISTER'),
        content: this.$t('HELP.KEYWORD1'),
      }, {
        title: this.$t('KEYWORD.ENRLL_PREV_KEY'),
        content: this.$t('HELP.KEYWORD2'),
      }],

      notice2: [{
        title: this.$t('KEYWORD.FORM_DWNLD'),
        content: this.$t('HELP.EDIT_KEYWORD1'),
      }, {
        title: this.$t('KEYWORD.UP_EXCEL'),
        content: this.$t('HELP.EDIT_KEYWORD2'),
      }, {
        title: this.$t('KEYWORD.DWN_EXCEL'),
        content: this.$t('HELP.EDIT_KEYWORD3'),
      }],
      lectureKeyword: [],
      pastKeyword: [],
      pastKeywordVisible: false,
      checkList: [],
      keywordPoint: [],
      prevKeyword: '',
      sorting: '',
      all_select: false,
      downloadLink: `${baseUrl}/downloads/keywordListForm`,
      fileTemp: null,
    };
  },
  computed: {
    ...mapState('keyword', [
      'addedkeywordList',
      'keywordList',
    ]),
    ...mapGetters('keyword', [
      'isKeywordDuplicated',
    ]),
    // 강의 키워드 총합 계산
    totalWeight() {
      return this.keywordList.reduce((totalWeight, item) => { // eslint-disable-line
        return (totalWeight + parseInt(item.weight, 10));
      }, 0);
    },
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.classId, 10);
    },
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
  methods: {
    ...mapMutations('keyword', [
      'updateMovedKeywordList',
      'updateAddedKeywordList',
      'updateKeywordList',
    ]),
    ...mapActions('keyword', [
      'deleteKeyword',
      'postLectureKeywords',
      'deleteLectureKeywords',
      'getKeywords',
      'editLectureKeywords',
      'NNpostLectureKeyword',
      'NNdeleteLectureKeyword',
      'NNputLectureKeyword',
    ]),
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    clearKeywordTab() {
      const vm = this;
      vm.multipleSelection.length = 0; // 파일목록 체크박스 배열 초기화
      vm.extractMode = 0; // 추출 모드 화면 번호 초기화
      vm.getKeywords();
    },
    async onClick(type, payload) {
      const vm = this;
      switch (type) {
        case 'EXPORT_EXCEL': {
          const res = await classService.getClass({
            id: vm.classId,
          });
          res.data.lectures.forEach((x) => {
            if (x.lecture_id === vm.lectureId) {
              const Name = `${x.name}_강의 키워드.xlsx`;
              vm.exportExcel(Name);
            }
          });
          break;
        }
        case 'ADD': {
          this.$refs.elForm.validate(async (valid) => { // TODO: valid 에러 : 제출후 빨간색으로 빈 칸이 강조됨.
            if (valid) {
              const keyname = this.input.keyword;
              const keyvalue = this.input.weight;
              // const keyvalue = this.input.keyword.keyvalue;
              if (keyname.length === 0) {
                // 존나 이유를 모르겠는데 가끔 keydown이 두번씩 들어옴 그걸 validate에서 거르지도 못함 병신임
                return;
              }
              // keyvalue의 값을 입력하지 않았거나 그 값이 1~100 사이의 값이 아닐 경우 다시 값을 요청받음
              if (keyvalue > 100 || keyvalue < 1 || keyvalue.length === 0) {
                vm.$notify({
                  title: vm.$t('NOTIFY.TITLE'),
                  message: vm.$t('NOTIFY.INPUT_SIGNIF_KEY'),
                  type: 'warning',
                });
                this.$refs.elForm.resetFields();
                return;
              }
              if (this.isKeywordDuplicated(keyname)) {
                // TODO: notify user the keyword is duplicated
                vm.$notify({
                  title: vm.$t('NOTIFY.TITLE'),
                  message: vm.$t('NOTIFY.ALRDY_ADDED_KEY'),
                  type: 'warning',
                });
                this.$refs.elForm.resetFields();
                return;
              }

              const res = await this.NNpostLectureKeyword({
                keyword: keyname,
                weight: keyvalue,
              });

              const dictKeyword = {};
              dictKeyword.keyword = res.data.keyword.keyword;
              dictKeyword.weight = res.data.keyword.weight;
              dictKeyword.keywordId = res.data.keyword.id;
              dictKeyword.edit = false;
              const newKeywordList = deepCopy(this.keywordList);
              newKeywordList.push(dictKeyword);
              this.updateKeywordList({
                keywordList: newKeywordList,
              });
              this.$refs.elForm.resetFields();
            }
          });
          break;
        }
        case 'ADD_KEYWORD': { // 키워드 자동 추출에서 키워드 추가
          if (this.isKeywordDuplicated(payload.keyword)) {
            // TODO: notify user the keyword is duplicated
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.DUP_KEY'),
              type: 'warning',
            });
            return;
          }
          const dictKeyword = {};
          dictKeyword.keyword = payload.keyword;
          dictKeyword.weight = payload.score;
          dictKeyword.edit = false;
          const newKeywordList = deepCopy(this.keywordList);
          newKeywordList.push(dictKeyword);
          this.updateKeywordList({
            keywordList: newKeywordList,
          });
          this.postLectureKeywords();
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.KEY_ADDED'),
            type: 'success',
          });
          break;
        }
        case 'DELETE_TAG': {
          const res = await this.NNdeleteLectureKeyword({ keywordId: payload.keywordId });
          if (res.data.success === true) {
            this.deleteKeyword({
              payload,
            });
          } else {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.CANNOT_DEL_ONGOING'),
              type: 'warning',
            });
          }
          // 강의 키워드 삭제 시 팝업 메시지
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.COMP_DELETE'),
            type: 'success',
          });
          break;
        }
        // 키워드 테이블에서 수정
        case 'EDIT_KEYWORD': {
          const keyvalue = payload.weight;

          let flag = false;
          // 등록된 키워드로 수정 시 오류 메시지
          vm.keywordList.forEach((keywords) => {
            if (keywords.keywordId !== payload.keywordId) {
              if(keywords.keyword === payload.keyword) {
                vm.$notify({
                  title: vm.$t('NOTIFY.TITLE'),
                  message: vm.$t('NOTIFY.IMP_MODIFY'),
                  type: 'error',
                });
                flag = true;
                return;
              }
            }
          });
          if (flag === true) {
            return;
          } else {
            // 먼저 이전 강의 키워드 갖고 있기(취소에 대비)
            vm.prevKeyword = payload.keyword;
          }
          
          // edit 아닌 상태
          if (payload.edit !== true) {
            const res = await this.NNputLectureKeyword(payload);
            if (res.data.success !== true) {
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.CANNOT_EDIT_ONGOING'),
                type: 'warning',
              });
              return;
            }
          }

          // edit 상태
          if (payload.edit === true) {
            // 유효성 검사 후 서버에 edit 요청 보냄
            if (keyvalue > 100 || keyvalue < 1 || keyvalue.length === 0) {
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.INPUT_SIGNIF_KEY'),
                type: 'warning',
              });
              return;
            }
            const res = await this.NNputLectureKeyword(payload);
            // 불가능하면 메시지 출력
            if (res.data.success !== true) {
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: res.data.message,
                type: 'warning',
              });
              return;
            }
            // 키워드 수정 완료 메세지 출력
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.COMP_MODIFY'),
              type: 'success',
            });
          }
          payload.edit = !payload.edit; // eslint-disable-line
          break;
        }
        case 'KEYWORD_EXTRACT_STEP_1': {
          vm.fileList.length = 0; // 추출할 파일 이름 목록 초기화
          const res = await lectureService.getAllFilesUnderLecture({
            lectureId: vm.$route.params.lectureId,
          });

          if (res.data.material_files instanceof Array) {
            res.data.material_files.forEach((element) => {
              element.name += ' @ 세션 자료 업로드'; // eslint-disable-line
              vm.fileList.push(element);
            });
          }

          if (res.data.note_files instanceof Array) {
            res.data.note_files.forEach((element) => {
              element.name += ' @ 세션 아이템 - 자료'; // eslint-disable-line
              vm.fileList.push(element);
            });
          }

          if (res.data.question_files instanceof Array) {
            res.data.question_files.forEach((element) => {
              element.name += ' @ 세션 아이템 - 문항'; // eslint-disable-line
              vm.fileList.push(element);
            });
          }

          this.extractMode = 1;
          break;
        }
        case 'KEYWORD_EXTRACT_STEP_2': {
          this.extractMode = 2;
          break;
        }
        case 'KEYWORD_EXTRACT_STEP_3': {
          vm.extractedKeywordList.splice(0, Number.MAX_VALUE);
          this.extractMode = 3;
          const res = await lectureService.autoExtractKeyword({
            lectureId: vm.$route.params.lectureId,
            guidList: vm.multipleSelection.map(x => x.file_guid),
            w1: vm.wordPercentage,
            w2: vm.fileAtLeast,
          });
          const wordToKeyword = res.data.keyword.map(x => ({
            keyword: x.word,
            score: x.score,
          }));
          wordToKeyword.forEach((element) => {
            vm.extractedKeywordList.push(element);
          });
          vm.extractMode = 4;
          break;
        }
        case 'CANCEL_EDIT': {
          // 키워드 수정 취소
          const vm = this;
          payload.keyword = vm.prevKeyword;
          payload.edit = !payload.edit; // eslint-disable-line
          break;
        }
        case 'IMPORT_KEYWORD': {
          const res = await lectureService.getLectureKeywords({
            lectureId: vm.$route.params.lectureId,
          });
          res.data.forEach((element) => {
            vm.lectureKeyword.push(element);
            for(let i = 0; i < vm.checkList.length; i += 1) {
              if(element.keyword === vm.checkList[i]) {
                vm.checkList.splice(vm.checkList[i], 1);
                break;
              }
            }
          });
          vm.checkList.forEach(async (x) => {
            const res2 = await this.NNpostLectureKeyword({
              keyword: x,
              weight: vm.keywordPoint,
            });
            const dictKeyword = {};
            dictKeyword.keyword = res2.data.keyword.keyword;
            dictKeyword.weight = res2.data.keyword.weight;
            dictKeyword.keywordId = res2.data.keyword.id;
            dictKeyword.edit = false;
            const newKeywordList = deepCopy(this.keywordList);
            newKeywordList.push(dictKeyword);
            this.updateKeywordList({
              keywordList: newKeywordList,
            });
            this.$refs.elForm.resetFields();
          });
          vm.checkList = [];
          vm.keywordPoint = null;
          break;
        }
        case 'ALL_KEYWORD': {
          const vm = this;
          vm.all_select = !vm.all_select;
          if(vm.all_select) {
            vm.pastKeyword.forEach((past) => {
              vm.checkList.push(past.keyword);
            });
          } else {
            vm.checkList = [];
          }
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    // 엑셀로 다운로드 기능 190716
    async exportExcel(Name) {
      const vm = this;
      let keywords = deepCopy(vm.keywordList);
      keywords.forEach((keyword) => {
        delete keyword.keywordId;
        delete keyword.edit;
        keyword['강의 키워드'] = keyword['keyword'];
        delete keyword.keyword;
        keyword['중요도'] = keyword['weight'];
        delete keyword.weight;
      });
      // export json to Worksheet of Excel
      // only array possible
      var keywordWS = XLSX.utils.json_to_sheet(keywords);

      var wb = XLSX.utils.book_new(); // make Workbook of Excel

      // add Worksheet to Workbook
      // Workbook contains one or more worksheets
      XLSX.utils.book_append_sheet(wb, keywordWS, '키워드'); // sheetAName is name of Worksheet

      // export Excel file
      XLSX.writeFile(wb, Name); // name of the file is '강의이름_키워드.xlsx'
    },
    sortUP() {
      const vm = this;
      let numbers = []; // 숫자끼리
      let englishs = []; // 영문끼리
      let koreans = []; // 한글끼리
      const pattern_num = /[0-9]/;	// 숫자
    	const pattern_eng = /[a-zA-Z]/;	// 문자
    	const pattern_kor = /[ㄱ-ㅎ|ㅏ-ㅣ|가-힣]/; // 한글
      vm.pastKeyword.forEach((key) => { // 첫단어가
        if(pattern_num.test(key.keyword[0])) { // 숫자이면
          numbers.push(key);
        } else if(pattern_eng.test(key.keyword[0])) { // 영문이면
          englishs.push(key);
        } else if(pattern_kor.test(key.keyword[0])) { // 한글이면
          koreans.push(key);
        }
      });
      /* 숫자, 영문, 한글 정렬 */
      numbers.sort(function(a, b) {
        return Number(a.keyword) < Number(b.keyword) ? -1 : Number(a.keyword) > Number(b.keyword) ? 1 : 0;
      });
      englishs.sort(function(a, b) {
        return a.keyword.toLowerCase() < b.keyword.toLowerCase() ? -1 : a.keyword.toLowerCase() > b.keyword.toLowerCase() ? 1 : 0;
      });
      koreans.sort(function(a, b) {
        return a.keyword < b.keyword ? -1 : a.keyword > b.keyword ? 1 : 0;
      });
      vm.pastKeyword = [];
      numbers.forEach((num) => {
        vm.pastKeyword.push(num);
      });
      englishs.forEach((eng) => {
        vm.pastKeyword.push(eng);
      });
      koreans.forEach((kor) => {
        vm.pastKeyword.push(kor);
      });
    },
    sortDOWN() {
      const vm = this;
      let numbers = []; // 숫자끼리
      let englishs = []; // 영문끼리
      let koreans = []; // 한글끼리
      const pattern_num = /[0-9]/;	// 숫자
    	const pattern_eng = /[a-zA-Z]/;	// 문자
    	const pattern_kor = /[ㄱ-ㅎ|ㅏ-ㅣ|가-힣]/; // 한글
      vm.pastKeyword.forEach((key) => { // 첫단어가
        if(pattern_num.test(key.keyword[0])) { // 숫자이면
          numbers.push(key);
        } else if(pattern_eng.test(key.keyword[0])) { // 영문이면
          englishs.push(key);
        } else if(pattern_kor.test(key.keyword[0])) { // 한글이면
          koreans.push(key);
        }
      });
      /* 숫자, 영문, 한글 정렬 */
      numbers.sort(function(a, b) {
        return Number(a.keyword) > Number(b.keyword) ? -1 : Number(a.keyword) < Number(b.keyword) ? 1 : 0;
      });
      englishs.sort(function(a, b) {
        return a.keyword.toLowerCase() > b.keyword.toLowerCase() ? -1 : a.keyword.toLowerCase() < b.keyword.toLowerCase() ? 1 : 0;
      });
      koreans.sort(function(a, b) {
        return a.keyword > b.keyword ? -1 : a.keyword < b.keyword ? 1 : 0;
      });
      vm.pastKeyword = [];
      numbers.forEach((num) => {
        vm.pastKeyword.push(num);
      });
      englishs.forEach((eng) => {
        vm.pastKeyword.push(eng);
      });
      koreans.forEach((kor) => {
        vm.pastKeyword.push(kor);
      });
    },
    //Processing Method for Uploading Files
    handleChange(file, fileList) {
      const vm = this;
      vm.fileTemp = file.raw;
      if(vm.fileTemp) {
          if((vm.fileTemp.type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet')) {
            vm.importfxx(vm.fileTemp);
          } else {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('KEYWORD.FORMAT_ERROR'),
              type:'warning',
            });
          }
      }
    },
    //Processing method when exceeding the maximum number of uploaded files
    handleExceed(){
      const vm = this;
      vm.$notify({
        title: vm.$t('NOTIFY.TITLE'),
        message: vm.$t('KEYWORD.MAXIMUM_ERROR'),
        type:'warning',
      })
      return;
    },
    //How to remove files
    handleRemove(file,fileList){
      const vm = this;
      vm.fileTemp = null;
    },
    importfxx(obj) {
      let vm = this;
      let inputDOM = vm.$refs.inputer;
      // Retrieving file data through DOM
      vm.file = event.currentTarget.files[0];
      var rABS = false; //Read the file as a binary string
      var f = vm.file;
      var reader = new FileReader();
      //if (!FileReader.prototype.readAsBinaryString) {
      FileReader.prototype.readAsBinaryString = function(f) {
        var binary = "";
        var rABS = false; //Read the file as a binary string
        var pt = vm;
        var wb; //Read completed data
        var outdata;
        var reader = new FileReader();
        reader.onload = function(e) {
          var bytes = new Uint8Array(reader.result);
          var length = bytes.byteLength;
          for (var i = 0; i < length; i++) {
            binary += String.fromCharCode(bytes[i]);
          }
          //If not introduced in main.js, you need to introduce it here to parse excel
          // var XLSX = require("xlsx");
          if (rABS) {
            wb = XLSX.read(btoa(fixdata(binary)), {
              //Manual conversion
              type: "base64"
            });
          } else {
            wb = XLSX.read(binary, {
              type: "binary"
            });
          }
          outdata = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]]); 
          //outdata is read data (without header rows or headers, the header will be the subscript of the object)
          //Data can be processed here.
          let arr = [];
          outdata.map(v => {
            let obj = {};
            obj.keyword = v['강의 키워드'];
            obj.weight = v['중요도'];
            arr.push(obj);
          });
          vm.da=arr;
          vm.dalen=arr.length;
          vm.uploadKeywords(arr); // 엑셀로부터 가져온 키워드와 중요도 등록하기
        };
        reader.readAsArrayBuffer(f);
      };
      if (rABS) {
        reader.readAsArrayBuffer(f);
      } else {
        reader.readAsBinaryString(f);
      }
    },
    uploadKeywords(keywords) {
      const vm = this;
      keywords.forEach(async (key) => {
        const keyname = key.keyword;
        const keyvalue = key.weight;
        if (keyname.length === 0) {
          // 존나 이유를 모르겠는데 가끔 keydown이 두번씩 들어옴 그걸 validate에서 거르지도 못함 병신임
          return;
        }
        // keyvalue의 값을 입력하지 않았거나 그 값이 1~100 사이의 값이 아닐 경우 다시 값을 요청받음
        if (keyvalue > 100 || keyvalue < 1 || keyvalue.length === 0) {
          return;
        }
        if (vm.isKeywordDuplicated(keyname)) {
          // TODO: notify user the keyword is duplicated
          return;
        }
        const res = await vm.NNpostLectureKeyword({
          keyword: keyname,
          weight: keyvalue,
        });

        const dictKeyword = {};
        dictKeyword.keyword = res.data.keyword.keyword;
        dictKeyword.weight = res.data.keyword.weight;
        dictKeyword.keywordId = res.data.keyword.id;
        dictKeyword.edit = false;
        const newKeywordList = deepCopy(vm.keywordList);
        newKeywordList.push(dictKeyword);
        vm.updateKeywordList({
          keywordList: newKeywordList,
        });
      });
      vm.$notify({
        title: vm.$t('NOTIFY.TITLE'),
        message: vm.$t('KEYWORD.UPLOAD_SUCCESS'),
        type:'success',
      });
    },
  },
};
</script>

<style lang="scss">
@import "~@/variables.scss";

#lecture_keywords_editor_wrapper {
  .el-input-group__append {
    background-color: lighten($--color-primary, 15%);
    i {
      color: lighten(yellow, 40%);
    }
  }
  .tag {
    padding: 0 2em;
  }
  #table_design {
    border-collapse: collapse;
    text-align: center;
    line-height: 1.5;
    border-top: 1px solid #321;
    border-bottom: 1px solid #321;
    border-block-end: 1px solid #321;
    margin: 20px 10px;
  }
  #table_design thead {
    width: 350px;
    padding: 10px;
    vertical-align: top;
    color: #111;
    background: rgb(160, 213, 250);
    margin: 20px 10px;
  }
  #table_design td {
    width: 350px;
    padding: 10px;
    font-size: 15px;
    color: #333;
  }
  #table_design tbody {
    border-bottom: 1px solid #321;
  }
  .box-container {
  display: flex;
  }
}
</style>